// Multidimensional dynamic arrays,
// open array parameters,
// open array constructors.

program DemoArr;

procedure Demo1( A : array of array of Real );
begin
  writeln( A ); // we can print any variable 
end;

procedure Demo2( var A : array of array of Real );
begin
  writeln( 'A=', A );
  A[ 0, 1 ] := 0.005;
  A[ 1, 0 ] := 1.E-7;
end;

var
  A, B : array of array of Real;
  C : array[ false..true, 'a'..'f' ] of Real;
  I, J : Integer;
begin
  writeln( A );

  SetLength( A, 5 );               // create 
  for I:=Low( A ) to High( A ) do  // a multidimensional dynamic array
    SetLength( A[I], I+1 );

  writeln( A ); 

  A[ 1, 0 ] := 345;
  writeln( A );

  writeln( Length( A ) );
  writeln( Length( A[ 2 ] ) );

  writeln( Length( C ) ); 

  SetLength( A, 3 ); // resize dynamic array
  writeln( A );

  B := Copy( A, 1, 2 ); // copy dynamic array
  writeln( B );

  Demo2( C ); // use static array

  Demo1( C ); // use static array 
  Demo1( B ); // use dynamic array
  Demo1( [[ 67, 88], [12, 14 ]] ); // use open array constructor

  SetLength( A, 0 ); // erase dynamic array 
  writeln( A );

  SetLength( B, 0 ); // erase dynamic array
  writeln( B );
end.
